/**********************************/
/*                                */
/*     dt_util.c                  */
/*                                */
/*     decision tree              */
/*     utility routines           */
/*                                */
/*     Alan Dix                   */
/*                                */
/*     26/11/1993                 */
/*                                */
/**********************************/

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "dt.h"

int is_leaf( decision dec )
{
    return ( dec.class == C_leaf );
}

int nos_choices( decision dec )
{
    if ( dec.class == C_leaf ) return 1;
    else                       return 2;
}

char *name_of_dec_op( dec_op op )
{
    switch ( op ) {
        case   OP_none:  return "** none **";
        case   OP_le:    return "<=";
        case   OP_lt:    return "<" ;
        case   OP_eq:    return "=";
        case   OP_in:    return "in";
        default:        return "** ERROR **";
      }
}

char *name_of_not_dec_op( dec_op op )
{
    switch ( op ) {
        case   OP_none:  return "** none **";
        case   OP_le:    return ">";
        case   OP_lt:    return ">=" ;
        case   OP_eq:    return "!=";
        case   OP_in:    return "not in";
        default:        return "** ERROR **";
      }
}

dec_op lookup_dec_op( char *name )
{
    if ( strcmp(name,"==") == 0 )  return OP_eq;
    if ( strcmp(name,"=")  == 0 )  return OP_eq;
    if ( strcmp(name,"<=") == 0 )  return OP_le;
    if ( strcmp(name,"<") == 0 )   return OP_lt;
    if ( strcmp(name,"in") == 0 )  return OP_in;
    return OP_none;
}

void copy_decision( decision *to, decision *from )
{
    to->class = from->class;
    to->op    = from->op;
    to->attr  = from->attr;
    switch ( to->class ) {
        case C_leaf:   to->inf.c_c.choice = from->inf.c_c.choice;
                       to->inf.c_c.cf     = from->inf.c_c.cf;
                       break;
        case N_const:  to->inf.n_c.val = from->inf.n_c.val;
                       break;
        case S_const:  to->inf.s_c.val = from->inf.s_c.val;
                       break;
        case S_set:    to->inf.s_s.nos_elems = from->inf.s_s.nos_elems;
                       assert(0);    /*  not yet implemented  */
                       break;
        case N_pair: case S_pair:
                       to->inf.pair.att2 = from->inf.pair.att2;
                       break;
        }
}

