/**********************************/
/*                                */
/*     gen_io.h                   */
/*                                */
/*     general input/output       */
/*     definitions                */
/*                                */
/*     Alan Dix                   */
/*                                */
/*     26/11/1993                 */
/*                                */
/**********************************/

#ifndef GEN_IO_H
#define GEN_IO_H

#include <stdio.h>

#define TOK_NUM  257
#define TOK_STR  258
#define TOK_VAR  259
#define TOK_SYM  300

#define TOK_SIZE 100

typedef int token;

extern char *read_error;

extern int token_debug;

extern int tok_len;
extern int tok_num;

extern char *tok_val;

int tok_is( char *str );
int tok_is_eof();
int tok_is_str();
int tok_is_num();
int tok_is_var( char *str );
int tok_is_sym( char *str );

int lookup( char *n, int size, char**names );

token read_token( FILE *fp );
token unread_token( FILE *fp );
void print_indent( FILE *fp, int indent );
int  ignore_spaces( FILE *fp );   /* returns EOF if no more tokens */
void ignore_line( FILE *fp );

int tok_at_eof( FILE *fp );
     /* looks ahead for end of file at next read */

void   print_read_error( FILE *to, FILE *from, char *str);

char ** read_string_list( FILE *fp, char *start, char *end, char *delim, int *len);

int is_var_name( char *str );

void print_num_field( FILE *fp, int size, int num );
void print_str_field( FILE *fp, int size, char *str );
void write_str_field( FILE *fp, int size, char *str );
void print_ch_field( FILE *fp, int size, char c );

#endif /*  GEN_IO_H  */



