/**********************************/
/*                                */
/*     strcmpl.c                  */
/*                                */
/*     missing string functions   */
/*                                */
/*     Alan Dix                   */
/*                                */
/*     26/11/1993                 */
/*                                */
/**********************************/

#include <stdlib.h>
#include <string.h>
#include "mem.h"

/*  case insensitive version of strcmp  */

int strcmpl( const char *s1, const char *s2 )
{
    const char *p1, *p2;
    for ( p1=s1, p2=s2; *p1; p1++, p2++ )
        if ( tolower(*p1) != tolower(*p2) ) return *p1 - *p2;
    return *p1 - *p2;
}

/*  duplicate and malloc string  */

char *strdup(const char *s)
{
	int len = strlen(s);
	char *new_s = (char*)malloc(len+1);
	strcpy(new_s,s);
	return new_s;
}
